<?php

namespace BuilderiusPro\Bundle\ACFBundle\GraphQL\Resolver;

use Builderius\Bundle\ACFBundle\GraphQL\Resolver\AbstractACFValueResolver;
use Builderius\GraphQL\Type\Definition\ResolveInfo;

class ACFMultipleTaxonomyValueResolver extends AbstractACFValueResolver
{
    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['name'])) {
            return null;
        }
        if (!$this->isOption && !$objectValue->ID) {
            return null;
        }
        $val = get_field($args['name'], $this->getOwnerId($objectValue));
        if (!is_array($val)) {
            return [];
        }
        foreach ($val as &$item) {
            if (is_int($item)) {
                $item = get_term_by('term_id', $item);
            } elseif(is_array($item) && isset($item['term_id'])) {
                $item = get_term_by('term_id', $item['term_id']);
            }

            if (!$item instanceof \WP_Term) {
                return [];
            }
        }

        return $val;
    }
}