<?php

namespace BuilderiusPro\Bundle\ACFBundle\GraphQL\Resolver;

use Builderius\Bundle\GraphQLBundle\Resolver\GraphQLFieldResolverInterface;
use Builderius\GraphQL\Type\Definition\ResolveInfo;

class ACFRepeaterRowTaxonomyValueResolver implements GraphQLFieldResolverInterface
{
    /**
     * @inheritDoc
     */
    public function getTypeNames()
    {
        return ['AcfRepeaterRow'];
    }

    /**
     * @inheritDoc
     */
    public function getFieldName()
    {
        return 'acf_taxonomy_value';
    }

    /**
     * @inheritDoc
     */
    public function getSortOrder()
    {
        return 10;
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($objectValue, array $args, $context, ResolveInfo $info)
    {
        return true;
    }

    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['name']) || !isset($objectValue[$args['name']])) {
            return new \stdClass();
        }
        $val = $objectValue[$args['name']];
        if (is_int($val)) {
            $val = get_term_by('term_id', $val);
        } elseif(is_array($val) && isset($val['term_id'])) {
            $val = get_term_by('term_id', $val['term_id']);
        }

        return $val instanceof \WP_Term ? $val : new \stdClass();
    }
}