<?php

namespace BuilderiusPro\Bundle\ACFBundle\GraphQL\Resolver;

use Builderius\Bundle\ACFBundle\GraphQL\Resolver\AbstractACFValueResolver;
use Builderius\GraphQL\Type\Definition\ResolveInfo;

class ACFTaxonomyValueResolver extends AbstractACFValueResolver
{
    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['name']) || (!$this->isOption && !$objectValue->ID)) {
            return null;
        }
        $val = get_field($args['name'], $this->getOwnerId($objectValue));
        if (is_int($val)) {
            $val = get_term_by('term_id', $val);
        } elseif(is_array($val) && isset($val['term_id'])) {
            $val = get_term_by('term_id', $val['term_id']);
        }

        return $val instanceof \WP_Term ? $val : new \stdClass();
    }
}