<?php

namespace BuilderiusPro\Bundle\BuilderBundle\Boot;

use Builderius\MooMoo\Platform\Bundle\KernelBundle\Boot\BootServiceInterface;
use Builderius\Symfony\Component\DependencyInjection\ContainerInterface;

class UserSwitchingCookiesConstantsDefinition implements BootServiceInterface
{
    /**
     * @inheritDoc
     */
    public function boot(ContainerInterface $container)
    {
        if ( ! defined( 'COOKIEHASH' ) ) {
            $siteurl = get_site_option( 'siteurl' );
            if ( $siteurl ) {
                define( 'COOKIEHASH', md5( $siteurl ) );
            } else {
                define( 'COOKIEHASH', '' );
            }
        }
        if ( ! defined( 'BUILDERIUS_USER_SWITCHING_COOKIE' ) ) {
            define( 'BUILDERIUS_USER_SWITCHING_COOKIE', 'builderius_user_sw_' . COOKIEHASH );
        }

        if ( ! defined( 'BUILDERIUS_USER_SWITCHING_SECURE_COOKIE' ) ) {
            define( 'BUILDERIUS_USER_SWITCHING_SECURE_COOKIE', 'builderius_user_sw_secure_' . COOKIEHASH );
        }

        if ( ! defined( 'BUILDERIUS_USER_SWITCHING_OLDUSER_COOKIE' ) ) {
            define( 'BUILDERIUS_USER_SWITCHING_OLDUSER_COOKIE', 'builderius_user_sw_olduser_' . COOKIEHASH );
        }
    }
}