<?php

namespace BuilderiusPro\Bundle\BuilderBundle\Hook;

use Builderius\Bundle\TemplateBundle\Cache\BuilderiusRuntimeObjectCache;
use Builderius\MooMoo\Platform\Bundle\HookBundle\Model\AbstractFilter;
use BuilderiusPro\Bundle\BuilderBundle\Helper\UserSwitchingHelper;

class BuilderiusGetCurrentUserHook extends AbstractFilter
{
    /**
     * @var BuilderiusRuntimeObjectCache
     */
    private $cache;

    /**
     * @param BuilderiusRuntimeObjectCache $cache
     * @return $this
     */
    public function setCache(BuilderiusRuntimeObjectCache $cache)
    {
        $this->cache = $cache;

        return $this;
    }

    /**
     * @inheritDoc
     */
    public function getFunction()
    {
        $user = $this->cache->get('builderius_current_user');
        if (false === $user) {
            $oldUser = UserSwitchingHelper::getOldUser();
            if ($oldUser && $oldUser->ID !== 0) {
                $user = $oldUser;
            } else {
                $user = func_get_arg(0);
            }
            $this->cache->set('builderius_current_user', $user);
        }

        return $user;
    }
}