<?php

namespace BuilderiusPro\Bundle\BuilderBundle\Hook;

use Builderius\MooMoo\Platform\Bundle\HookBundle\Model\AbstractAction;
use BuilderiusPro\Bundle\BuilderBundle\Helper\UserSwitchingHelper;

class UserSwitchingAdminBarMyAccountMenuForSwitchedUserHook extends AbstractAction
{
    /**
     * @inheritDoc
     */
    public function getFunction()
    {
        global $wp_admin_bar;

        $user_id      = get_current_user_id();
        $current_user = wp_get_current_user();

        $old_user = UserSwitchingHelper::getOldUser();

        if ( !$old_user || $old_user->ID === 0 ) {
            return;
        }

        $avatar = get_avatar( $old_user->ID, 26 );
        /* translators: %s: Current user's display name. */
        $howdy = sprintf( __( 'Howdy, %s' ), '<span class="display-name">' . $old_user->display_name . '(on behalf of ' . ($user_id != 0 ? $current_user->display_name : 'unauthenticated user') . ')</span>' );
        $class = empty( $avatar ) ? '' : 'with-avatar';

        $wp_admin_bar->add_node(
            array(
                'id'     => 'my-account',
                'parent' => 'top-secondary',
                'title'  => $howdy . $avatar,
                'href'   => false,
                'meta'   => array(
                    'class' => $class,
                ),
            )
        );
    }
}