<?php

namespace BuilderiusPro\Bundle\BuilderBundle\Hook;

use Builderius\MooMoo\Platform\Bundle\HookBundle\Model\AbstractAction;
use BuilderiusPro\Bundle\BuilderBundle\Helper\UserSwitchingHelper;

class UserSwitchingClearOldUserCookieHook extends AbstractAction
{
    /**
     * @inheritDoc
     */
    public function getFunction()
    {
        $login = false;
        $logout = false;
        $userId = func_get_arg(0);
        if (is_int($userId)) {
            $logout = true;
            $user = get_userdata($userId);
        } else {
            $login = true;
            $user = func_get_arg(1);
        }
        if ($user && $user->has_cap('builderius-development')) {
            UserSwitchingHelper::clearOldUserCookie();
            update_user_meta($user->ID, 'builderius_dev_preview_as', 'own_user');
        } else {
            $oldUser = UserSwitchingHelper::getOldUser();
            if ($logout === true) {
                update_user_meta($oldUser->ID, 'builderius_dev_preview_as', 'unauthenticated');
            } elseif($login === true) {
                update_user_meta($oldUser->ID, 'builderius_dev_preview_as', 'user_' . $user->ID);
            }
        }
    }
}