<?php

namespace BuilderiusPro\Bundle\BuilderBundle\Registration;

use Builderius\MooMoo\Platform\Bundle\MenuBundle\Model\AdminBarNode;
use BuilderiusPro\Bundle\BuilderBundle\Helper\UserSwitchingHelper;

class BuilderiusPreviewAsAdminNavBarNode extends AdminBarNode
{
    public function getTitle()
    {
        return __('Preview As', 'builderius') . '<select id="builderius-preview-as-select">' . $this->generateOptions() . '</select>';
    }

    /**
     * @return string
     */
    private function generateOptions()
    {
        $user = apply_filters('builderius_get_current_user', wp_get_current_user());
        $previewAs = get_user_meta($user->ID, 'builderius_dev_preview_as', true) ? : 'own_user';
        $array = [
            UserSwitchingHelper::switchBackUrl($user) => $user->display_name . '(' . __('own user', 'builderius') . ')'
        ];
        $otherUsers = get_users([
            'exclude' => $user->ID,
        ]);
        if (!is_admin()) {
            $array[UserSwitchingHelper::switchOffUrl($user)] = __('unauthenticated user', 'builderius');
        }
        foreach ($otherUsers as $otherUser) {
            if (!$otherUser->has_cap('builderius-development')) {
                $roles = $otherUser->roles;
                $role = array_key_exists(0, $roles) ? translate_user_role(ucfirst($roles[0])) : 'none';
                $array[UserSwitchingHelper::switchToUrl($otherUser)] = $otherUser->display_name . '(' . __('Role') . ': ' . $role . ', ' . __('Email') . ': ' . $otherUser->user_email . ')';
            }
        }

        $options = '';
        foreach ($array as $key => $value) {
            $selected = false;
            if (strpos($key, sprintf('builderius_switch_to_%s', $previewAs)) !== false) {
                $selected = true;
            } elseif (strpos($key, 'builderius_switch_to_user') !== false) {
                $arr = explode('_', $previewAs);
                if ($arr[0] === 'user' && strpos($key, sprintf('user_id=%s', $arr[1])) !== false)
                    $selected = true;
            }
            $options .= '<option value="' . $key . '" ' . ($selected === true ? 'selected="selected"' : '') . '>' . $value . '</option>';
        }

        return $options;
    }
}