<?php

namespace BuilderiusPro\Bundle\ComponentBundle\Condition;

use Builderius\MooMoo\Platform\Bundle\ConditionBundle\Model\AbstractCondition;
use BuilderiusPro\Bundle\ComponentBundle\Provider\DeliverableTemplatePartSubModule\DeliverableTemplatePartSubModuleProviderInterface;

class HasNoAppliedBuilderiusDeliverableTemplatePartCondition extends AbstractCondition
{
    /**
     * @var DeliverableTemplatePartSubModuleProviderInterface
     */
    private $builderiusDtpsmProvider;

    /**
     * @param DeliverableTemplatePartSubModuleProviderInterface $builderiusDtpsmProvider
     * @return $this
     */
    public function setBuilderiusDeliverableTemplatePartSubModuleProvider(
        DeliverableTemplatePartSubModuleProviderInterface $builderiusDtpsmProvider
    ) {
        $this->builderiusDtpsmProvider = $builderiusDtpsmProvider;

        return $this;
    }

    /**
     * @inheritDoc
     */
    protected function getResult()
    {
        if(!isset($_GET['builderius-template-part-type'])) {
            return true;
        }
        if ($this->builderiusDtpsmProvider->getTemplatePartSubModule($_GET['builderius-template-part-type'])) {
            return false;
        }

        return true;
    }
}