<?php

namespace BuilderiusPro\Bundle\ComponentBundle\DependencyInjection\CompilerPass;

use Builderius\Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Builderius\Symfony\Component\DependencyInjection\ContainerBuilder;

class TemplateHooksAndListenersDecorationCompilerPass implements CompilerPassInterface
{
    /**
     * @inheritDoc
     */
    public function process(ContainerBuilder $container)
    {
        $hasAppliedComponentCondition = $container->getDefinition('has_applied_builderius_component');
        $hasNoAppliedComponentCondition = $container->getDefinition('has_no_applied_builderius_component');

        $hasAppliedDeliverableComponentCondition = $container->getDefinition('has_applied_builderius_deliverable_component');
        $hasNoAppliedDeliverableComponentCondition = $container->getDefinition('has_no_applied_builderius_deliverable_component');

        $hasAppliedAnyOfBuilderiusEntitiesCondition = $container->getDefinition('builderius_builder.condition.has_applied_any_of_builderius_entities');
        $hasAppliedAnyOfBuilderiusEntitiesCondition->addMethodCall('addCondition', [$hasAppliedComponentCondition]);

        $hasAppliedAnyOfDeliverableBuilderiusEntitiesCondition = $container->getDefinition('builderius_builder.condition.has_applied_any_of_deliverable_builderius_entities');
        $hasAppliedAnyOfDeliverableBuilderiusEntitiesCondition->addMethodCall('addCondition', [$hasAppliedDeliverableComponentCondition]);


        $templateHtmlInsertionHookInPreviewMode = $container->getDefinition('builderius_template.hook.html_insertion_in_preview_mode');
        $templateHtmlInsertionHookInPreviewMode->addMethodCall('addCondition', [$hasNoAppliedComponentCondition]);

        $templateAtRulesRegistrationListenerInPreviewMode = $container->getDefinition('builderius_template.event_listener.inline_assets_registration.at_rules.preview');
        $templateAtRulesRegistrationListenerInPreviewMode->addMethodCall('addCondition', [$hasNoAppliedComponentCondition]);

        $gsettingsAtRulesRegistrationListenerInPreviewMode = $container->getDefinition('builderius_setting.event_listener.inline_assets_registration.at_rules.preview');
        $gsettingsAtRulesRegistrationListenerInPreviewMode->addMethodCall('addCondition', [$hasNoAppliedComponentCondition]);

        $templateCssRegistrationListenerInPreviewMode = $container->getDefinition('builderius_template.event_listener.inline_assets_registration.css.preview');
        $templateCssRegistrationListenerInPreviewMode->addMethodCall('addCondition', [$hasNoAppliedComponentCondition]);

        $gsettingsCssRegistrationListenerInPreviewMode = $container->getDefinition('builderius_setting.event_listener.inline_assets_registration.css.preview');
        $gsettingsCssRegistrationListenerInPreviewMode->addMethodCall('addCondition', [$hasNoAppliedComponentCondition]);

        $modulesAssetsRegistrationListenerInPreviewMode = $container->getDefinition('builderius_template.event_listener.inline_assets_registration.modules_assets.preview');
        $modulesAssetsRegistrationListenerInPreviewMode->addMethodCall('addCondition', [$hasNoAppliedComponentCondition]);


        $templateHtmlInsertionHookInFrontendMode = $container->getDefinition('builderius_template.hook.html_insertion_in_frontend_mode');
        $templateHtmlInsertionHookInFrontendMode->addMethodCall('addCondition', [$hasNoAppliedDeliverableComponentCondition]);

        $templateAtRulesRegistrationListenerInFrontendMode = $container->getDefinition('builderius_template.event_listener.inline_assets_registration.at_rules.frontend');
        $templateAtRulesRegistrationListenerInFrontendMode->addMethodCall('addCondition', [$hasNoAppliedDeliverableComponentCondition]);

        $gsettingsAtRulesRegistrationListenerInFrontendMode = $container->getDefinition('builderius_setting.event_listener.inline_assets_registration.at_rules.frontend');
        $gsettingsAtRulesRegistrationListenerInFrontendMode->addMethodCall('addCondition', [$hasNoAppliedDeliverableComponentCondition]);

        $templateCssRegistrationListenerInFrontendMode = $container->getDefinition('builderius_template.event_listener.inline_assets_registration.css.frontend');
        $templateCssRegistrationListenerInFrontendMode->addMethodCall('addCondition', [$hasNoAppliedDeliverableComponentCondition]);

        $gsettingsCssRegistrationListenerInFrontendMode = $container->getDefinition('builderius_setting.event_listener.inline_assets_registration.css.frontend');
        $gsettingsCssRegistrationListenerInFrontendMode->addMethodCall('addCondition', [$hasNoAppliedDeliverableComponentCondition]);

        $modulesAssetsRegistrationListenerInFrontendMode = $container->getDefinition('builderius_template.event_listener.inline_assets_registration.modules_assets.frontend');
        $modulesAssetsRegistrationListenerInFrontendMode->addMethodCall('addCondition', [$hasNoAppliedDeliverableComponentCondition]);
    }
}
