<?php

namespace BuilderiusPro\Bundle\ComponentBundle\EventListener;

use Builderius\Bundle\DeliverableBundle\Event\BuilderiusDSMPostCreationEvent;
use Builderius\Bundle\TemplateBundle\Model\BuilderiusTemplate;
use Builderius\Bundle\TemplateBundle\Model\BuilderiusTemplateInterface;

class BuilderiusTemplatePartDSMPostCreationEventListener
{
    /**
     * @param BuilderiusDSMPostCreationEvent $event
     */
    public function onDSMPostCreation(BuilderiusDSMPostCreationEvent $event)
    {
        $owner = $event->getVcsOwner();
        if ($owner instanceof BuilderiusTemplateInterface && $owner->getType() === 'template_part') {
            $event
                ->setType($owner->getSubType())
                ->setEntityType('template_part')
                ->setAttributes(
                    [
                        BuilderiusTemplate::SORT_ORDER_FIELD => $owner->getSortOrder(),
                        BuilderiusTemplate::APPLY_RULES_CONFIG_FIELD => $owner->getApplyRulesConfig()
                    ]
                )
                ->setTitle($owner->getTitle());
            $event->stopPropagation();
        }
    }
}