<?php

namespace BuilderiusPro\Bundle\ComponentBundle\EventListener;

use Builderius\Bundle\GraphQLBundle\Resolver\GraphQLFieldResolverInterface;
use Builderius\Bundle\VCSBundle\Event\BuilderiusVCSOwnersResolveEvent;

class BuilderiusTemplatePartVCSOwnersResolveEventListener
{
    /**
     * @var GraphQLFieldResolverInterface
     */
    private $templateResolver;

    /**
     * @param GraphQLFieldResolverInterface $templateResolver
     */
    public function __construct(
        GraphQLFieldResolverInterface $templateResolver
    ) {
        $this->templateResolver = $templateResolver;
    }

    /**
     * @param BuilderiusVCSOwnersResolveEvent $event
     */
    public function onResolve(BuilderiusVCSOwnersResolveEvent $event)
    {
        $args = $event->getArgs();
        $args['type'] = 'template_part';
        $templates = $this->templateResolver->resolve(
            $event->getObjectValue(),
            $args,
            $event->getContext(),
            $event->getInfo()
        );
        $owners = array_merge($event->getVscOwners(), $templates);
        $event->setVscOwners($owners);
    }
}