<?php

namespace BuilderiusPro\Bundle\ComponentBundle\EventListener;

use Builderius\Bundle\ModuleBundle\Event\DynamicDataConditionEvaluationEvent;
use BuilderiusPro\Bundle\ComponentBundle\Twig\TemplatePartDataVarsExtension;

class DynamicDataConditionEvaluationEventListener
{
    /**
     * @var TemplatePartDataVarsExtension
     */
    private $templatePartDataVarsTwigExtension;

    /**
     * @param TemplatePartDataVarsExtension $templatePartDataVarsTwigExtension
     */
    public function __construct(
        TemplatePartDataVarsExtension $templatePartDataVarsTwigExtension
    ) {
        $this->templatePartDataVarsTwigExtension = $templatePartDataVarsTwigExtension;
    }

    /**
     * @param DynamicDataConditionEvaluationEvent $event
     * @return void
     */
    public function onDynamicDataConditionEvaluation(DynamicDataConditionEvaluationEvent $event)
    {
        $function = $event->getFunction();
        $arguments = $event->getArguments();
        if ($function === 'builderius_tp_data_var') {
            $event->setValue($this->templatePartDataVarsTwigExtension->getNonEscapedDataVarValue($arguments[0], $arguments[1]), false);
        } elseif ($function === 'builderius_tp_data_var_escaped') {
            $event->setValue($this->templatePartDataVarsTwigExtension->getEscapedDataVarValue($arguments[0], $arguments[1]));
        }
    }
}