<?php

namespace BuilderiusPro\Bundle\ComponentBundle\Hook;

use Builderius\Bundle\TemplateBundle\Provider\Content\Template\BuilderiusTemplateHtmlContentProvider;
use Builderius\MooMoo\Platform\Bundle\HookBundle\Model\AbstractFilter;
use Builderius\Symfony\Component\Templating\EngineInterface;
use BuilderiusPro\Bundle\ComponentBundle\Provider\DeliverableTemplatePartSubModule\DeliverableTemplatePartSubModuleProviderInterface;

class HtmlInsertionInFrontendModeHook extends AbstractFilter
{
    /**
     * @var DeliverableTemplatePartSubModuleProviderInterface
     */
    private $dtpsmProvider;

    /**
     * @var EngineInterface
     */
    private $templatingEngine;

    /**
     * @param DeliverableTemplatePartSubModuleProviderInterface $dtpsmProvider
     * @return $this
     */
    public function setBuilderiusDeliverableTemplatePartSubModuleProvider(
        DeliverableTemplatePartSubModuleProviderInterface $dtpsmProvider
    ) {
        $this->dtpsmProvider = $dtpsmProvider;

        return $this;
    }

    /**
     * @param EngineInterface $templatingEngine
     * @return $this
     */
    public function setTemplatingEngine(EngineInterface $templatingEngine)
    {
        $this->templatingEngine = $templatingEngine;
        return $this;
    }

    /**
     * @inheritDoc
     */
    public function getFunction()
    {
        $type = func_get_arg(0);
        $templatePartSm = $this->dtpsmProvider->getTemplatePartSubModule($type);
        if ($templatePartSm) {
            if ($builderiusHtml = $templatePartSm->getContent(BuilderiusTemplateHtmlContentProvider::CONTENT_TYPE)) {
                $builderiusHtml = str_replace('builderius_data_var(', sprintf('builderius_tp_data_var(\'%s\', ', $templatePartSm->getType()), $builderiusHtml);
                $builderiusHtml = str_replace('builderius_data_var_escaped(', sprintf('builderius_tp_data_var_escaped(\'%s\', ', $templatePartSm->getType()), $builderiusHtml);
                $builderiusHtml = str_replace('builderius_visibility_condition(', sprintf('builderius_tp_visibility_condition(\'%s\', ', $templatePartSm->getType()), $builderiusHtml);

                return do_blocks(do_shortcode($this->templatingEngine->render(
                    'BuilderiusTemplateBundle:templateDynamicContent.twig',
                    [
                        'dynamicContent' => $builderiusHtml
                    ]
                )));
            }
        }
        
        return '';
    }
}
