<?php

namespace BuilderiusPro\Bundle\ComponentBundle\Registration;

use Builderius\Bundle\BuilderBundle\Registration\AbstractBuilderiusBuilderScriptLocalization;
use Builderius\Bundle\TemplateBundle\ApplyRule\Starter\Registry\BuilderiusTemplateApplyRuleStartersRegistryInterface;

class BuilderiusTemplatePartApplyRulesStartersScriptLocalization extends AbstractBuilderiusBuilderScriptLocalization
{
    const PROPERTY_NAME = 'applyRulesStarters';

    /**
     * @var BuilderiusTemplateApplyRuleStartersRegistryInterface
     */
    private $templateApplyRuleStartersRegistry;

    /**
     * @param BuilderiusTemplateApplyRuleStartersRegistryInterface $templateApplyRuleStartersRegistry
     */
    public function __construct(
        BuilderiusTemplateApplyRuleStartersRegistryInterface $templateApplyRuleStartersRegistry
    ) {
        $this->templateApplyRuleStartersRegistry = $templateApplyRuleStartersRegistry;
    }

    /**
     * @inheritDoc
     */
    public function getPropertyData()
    {
        $result = [];
        $starters = $this->templateApplyRuleStartersRegistry->getStarters();
        foreach ($starters as $starter){
            if ($starter->isValid()) {
                foreach ($starter->getTechnologies() as $technology) {
                    if (!isset($result[$technology])) {
                        $result[$technology] = [];
                    }
                    if (in_array('template_part', $starter->getTemplateTypes())) {
                        $result[$technology]['template_part'][$starter->getCategory()][$starter->getName()] = [
                            'title' => $starter->getTitle(),
                            'cfg' => $starter->getConfig()
                        ];
                    }
                }
            }
        }
        
        return $result;
    }
}
