<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\DependencyInjection;

use Builderius\Symfony\Component\Config\FileLocator;
use Builderius\Symfony\Component\DependencyInjection\ContainerBuilder;
use Builderius\Symfony\Component\DependencyInjection\Extension\Extension;
use Builderius\Symfony\Component\DependencyInjection\Loader;

class BuilderiusProGraphQLExtension extends Extension
{
    /**
     * {@inheritdoc}
     */
    public function load(array $configs, ContainerBuilder $container)
    {
        $loader = new Loader\YamlFileLoader($container, new FileLocator(__DIR__.'/../Resources/config'));
        $loader->load('services.yml');
        $loader->load('resolvers.yml');
        $loader->load('common_types_configs.yml');
        $loader->load('term_types_configs.yml');
        $loader->load('post_types_configs.yml');
        $loader->load('user_types_configs.yml');
        $loader->load('posts_facets_types_configs.yml');
        $loader->load('pagination_types_configs.yml');
        $loader->load('wp_query_types_configs.yml');
        $loader->load('wp_date_query_types_configs.yml');
        $loader->load('wp_meta_query_types_configs.yml');
        $loader->load('wp_tax_query_types_configs.yml');
        $loader->load('wp_term_query_types_configs.yml');
        $loader->load('wp_user_query_types_configs.yml');
        $loader->load('php_function_output_configs.yml');
        $loader->load('expression_result_configs.yml');
        $loader->load('nav_menu_types_configs.yml');
    }
}
