<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\Event;

use Builderius\Symfony\Contracts\EventDispatcher\Event;

class FacetDataSourceCalculationEvent extends Event
{
    /**
     * @var string
     */
    private $dataSourceName;

    /**
     * @var array
     */
    private $dataSourceArguments;

    /**
     * @var array
     */
    private $facetData;

    /**
     * @param string $dataSourceName
     * @param array $dataSourceArguments
     */
    public function __construct(
        $dataSourceName,
        array $dataSourceArguments
    ) {
        $this->dataSourceName = $dataSourceName;
        $this->dataSourceArguments = $dataSourceArguments;
    }

    /**
     * @return string
     */
    public function getDataSourceName()
    {
        return $this->dataSourceName;
    }

    /**
     * @param string $dataSourceName
     * @return $this
     */
    public function setDataSourceName(string $dataSourceName)
    {
        $this->dataSourceName = $dataSourceName;

        return $this;
    }

    /**
     * @return array
     */
    public function getDataSourceArguments()
    {
        return $this->dataSourceArguments;
    }

    /**
     * @param array $dataSourceArguments
     * @return $this
     */
    public function setDataSourceArguments(array $dataSourceArguments)
    {
        $this->dataSourceArguments = $dataSourceArguments;

        return $this;
    }

    /**
     * @return array
     */
    public function getFacetData()
    {
        return $this->facetData;
    }

    /**
     * @param array $facetData
     * @return $this
     */
    public function setFacetData(array $facetData)
    {
        $this->facetData = $facetData;

        return $this;
    }
}