<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\EventListener;

use Builderius\Bundle\GraphQLBundle\Config\GraphQLFieldConfigInterface;
use Builderius\Bundle\GraphQLBundle\Config\GraphQLObjectTypeConfigInterface;
use Builderius\Bundle\TemplateBundle\Event\ConfigContainingEvent;

class ExpressionResultFieldAddingToAllGraphQLObjectTypesListener
{
    /**
     * @var GraphQLFieldConfigInterface
     */
    private $expressionResultFieldConfig;

    /**
     * @param GraphQLFieldConfigInterface $expressionResultFieldConfig
     */
    public function __construct(
        GraphQLFieldConfigInterface $expressionResultFieldConfig
    )
    {
        $this->expressionResultFieldConfig = $expressionResultFieldConfig;
    }

    /**
     * @param ConfigContainingEvent $event
     */
    public function beforeGetGraphqlTypeConfigs(ConfigContainingEvent $event)
    {
        $configs = $event->getConfig();
        foreach ($configs as &$config) {
            if ($config instanceof GraphQLObjectTypeConfigInterface) {
                $config->addField($this->expressionResultFieldConfig);
            }
        }
    }
}