<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\EventListener;

use BuilderiusPro\Bundle\GraphQLBundle\Event\FacetDataSourceCalculationEvent;

class FacetCustomDataSourceCalculationListener
{
    /**
     * @param FacetDataSourceCalculationEvent $event
     */
    public function onDataSourceCalculation(FacetDataSourceCalculationEvent $event)
    {
        $name = $event->getDataSourceName();
        if ('custom' === $name) {
            $args = $event->getDataSourceArguments();
            $data = [];
            if(isset($args['items'])) {
                foreach ($args['items'] as $item) {
                    $data[] = (object)$item;
                }
            }
            $event->setFacetData($data);
            $event->stopPropagation();
        }
    }
}