<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\EventListener;

use BuilderiusPro\Bundle\GraphQLBundle\Event\FacetDataSourceCalculationEvent;

class FacetPostMetaValuesDataSourceCalculationListener
{
    /**
     * @param FacetDataSourceCalculationEvent $event
     */
    public function onDataSourceCalculation(FacetDataSourceCalculationEvent $event)
    {
        $name = $event->getDataSourceName();
        if ('postmeta_values' === $name) {
            global $wpdb;
            $args = $event->getDataSourceArguments();
            if (isset($args['post_status']) && isset($args['post_type'])) {
                $values = $wpdb->get_col(
                    $wpdb->prepare("
                    SELECT pm.meta_value FROM {$wpdb->postmeta} pm
                    LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
                    WHERE pm.meta_key = %s 
                    AND p.post_status = %s 
                    AND p.post_type = %s
                    ",
                        sanitize_key($args['key']),
                        sanitize_text_field($args['post_status']),
                        sanitize_text_field($args['post_type']),
                    )
                );
            } elseif (isset($args['post_status'])) {
                $values = $wpdb->get_col(
                    $wpdb->prepare("
                    SELECT pm.meta_value FROM {$wpdb->postmeta} pm
                    LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
                    WHERE pm.meta_key = %s 
                    AND p.post_status = %s 
                    ",
                        sanitize_key($args['key']),
                        sanitize_text_field($args['post_status']),
                    )
                );
            } elseif (isset($args['post_type'])) {
                $values = $wpdb->get_col(
                    $wpdb->prepare("
                    SELECT pm.meta_value FROM {$wpdb->postmeta} pm
                    LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
                    WHERE pm.meta_key = %s 
                    AND p.post_type = %s 
                    ",
                        sanitize_key($args['key']),
                        sanitize_text_field($args['post_type']),
                    )
                );
            } else {
                $values = $wpdb->get_col(
                    $wpdb->prepare("
                    SELECT pm.meta_value FROM {$wpdb->postmeta} pm
                    LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
                    WHERE pm.meta_key = %s 
                    ",
                        sanitize_key($args['key']),
                    )
                );
            }
            $data = [];
            foreach ($values as $value) {
                $data[] = (object)['value' => $value, 'label' => $value];
            }
            $event->setFacetData($data);
            $event->stopPropagation();
        }
    }
}