<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\EventListener;

use BuilderiusPro\Bundle\GraphQLBundle\Event\FacetDataSourceCalculationEvent;

class FacetTermsDataSourceCalculationListener
{
    /**
     * @param FacetDataSourceCalculationEvent $event
     */
    public function onDataSourceCalculation(FacetDataSourceCalculationEvent $event)
    {
        $name = $event->getDataSourceName();
        if ('terms' === $name) {
            $args = $event->getDataSourceArguments();
            $query = isset($args['query']) ? $args['query'] : [];
            if (!empty($query)) {
                if (isset($query['meta_query']) && isset($query['meta_query']['array'])) {
                    $metaQuery = $query['meta_query']['array'];
                    if (isset($query['meta_query']['relation'])) {
                        $metaQuery['relation'] = $query['meta_query']['relation'];
                    }
                    $query['meta_query'] = $metaQuery;
                }
            }
            $terms = get_terms($query);
            $data = [];
            foreach ($terms as $term) {
                $data[] = (object)[
                    'value' => (isset($args['value_field']) && property_exists($term, $args['value_field'])) ? $term->{$args['value_field']} : $term->term_id,
                    'label' => (isset($args['label_field']) && property_exists($term, $args['label_field'])) ? $term->{$args['label_field']} : $term->name
                ];
            }
            $event->setFacetData($data);
            $event->stopPropagation();
        }
    }
}