<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\EventListener;

use BuilderiusPro\Bundle\GraphQLBundle\Event\FacetDataSourceCalculationEvent;

class FacetUsersDataSourceCalculationListener
{
    /**
     * @param FacetDataSourceCalculationEvent $event
     */
    public function onDataSourceCalculation(FacetDataSourceCalculationEvent $event)
    {
        $name = $event->getDataSourceName();
        if ('users' === $name) {
            $args = $event->getDataSourceArguments();
            $args = isset($args['query']) ? $args['query'] : ['orderby' => 'login'];
            if (isset($args['meta_query']) && isset($args['meta_query']['array'])) {
                $metaQuery = $args['meta_query']['array'];
                if (isset($args['meta_query']['relation'])) {
                    $metaQuery['relation'] = $args['meta_query']['relation'];
                }
                $args['meta_query'] = $metaQuery;
            }
            wp_parse_args($args);
            $wpUserQuery = new \WP_User_Query($args);
            $users = (array)$wpUserQuery->get_results();
            $data = [];
            /** @var \WP_User $user */
            foreach ($users as $user) {
                $data[] = (object)[
                    'value' => (isset($args['value_field']) && property_exists($user, $args['value_field'])) ? $user->{$args['value_field']} : $user->ID,
                    'label' => (isset($args['label_field']) && property_exists($user, $args['label_field'])) ? $user->{$args['label_field']} : $user->display_name
                ];
            }
            $event->setFacetData($data);
            $event->stopPropagation();
        }
    }
}