<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\EventListener;

use Builderius\Bundle\GraphQLBundle\Config\GraphQLFieldConfigInterface;
use Builderius\Bundle\GraphQLBundle\Config\GraphQLObjectTypeConfigInterface;
use Builderius\Bundle\TemplateBundle\Event\ConfigContainingEvent;

class PhpFunctionOutputFieldAddingToAllGraphQLObjectTypesListener
{
    /**
     * @var GraphQLFieldConfigInterface
     */
    private $phpFunctionOutputFieldConfig;

    /**
     * @param GraphQLFieldConfigInterface $phpFunctionOutputFieldConfig
     */
    public function __construct(
        GraphQLFieldConfigInterface $phpFunctionOutputFieldConfig
    )
    {
        $this->phpFunctionOutputFieldConfig = $phpFunctionOutputFieldConfig;
    }

    /**
     * @param ConfigContainingEvent $event
     */
    public function beforeGetGraphqlTypeConfigs(ConfigContainingEvent $event)
    {
        $configs = $event->getConfig();
        foreach ($configs as &$config) {
            if ($config instanceof GraphQLObjectTypeConfigInterface) {
                $config->addField($this->phpFunctionOutputFieldConfig);
            }
        }
    }
}