<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\Provider\RootData;

use Builderius\Bundle\GraphQLBundle\Provider\RootData\BuilderiusGraphQLRootDataProviderInterface;

class GraphQLRootDataProvider implements BuilderiusGraphQLRootDataProviderInterface
{
    /**
     * @inheritDoc
     */
    public function getRootData(array $args = [])
    {
        $queriedPost = new \WP_Post((object)[]);
        $queriedUser = new \WP_User();
        $queriedTerm = new \WP_Term((object)[]);
        $queriedPostType = new \WP_Post_Type(null);

        $queriedObject = get_queried_object();

        if ($queriedObject instanceof \WP_Post) {
            $queriedPost = $queriedObject;
        }
        if ($queriedObject instanceof \WP_User) {
            $queriedUser = $queriedObject;
        }
        if ($queriedObject instanceof \WP_Term) {
            $queriedTerm = $queriedObject;
        }
        if ($queriedObject instanceof \WP_Post_Type) {
            $queriedPostType = $queriedObject;
        }

        return (object)[
            'queried_post' => $queriedPost,
            'queried_user' => $queriedUser,
            'queried_term' => $queriedTerm,
            'queried_post_type' => $queriedPostType
        ];
    }
}