<?php

namespace BuilderiusPro\Bundle\GraphQLBundle\Resolver;

use Builderius\Bundle\GraphQLBundle\Resolver\AbstractLocalVarsAwareResolver;
use Builderius\GraphQL\Type\Definition\ResolveInfo;

class PostCategoriesResolver extends AbstractLocalVarsAwareResolver
{
    /**
     * @inheritDoc
     */
    public function getTypeNames()
    {
        return ['Post'];
    }

    /**
     * @inheritDoc
     */
    public function getSortOrder()
    {
        return 10;
    }

    /**
     * @inheritDoc
     */
    public function getFieldName()
    {
        return 'categories';
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($objectValue, array $args, $context, ResolveInfo $info)
    {
        return true;
    }

    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        $query = isset($args['query']) ? $args['query'] : [];
        $query = $this->processArguments($query, $info->path);
        $query['fields'] = 'all';
        /** @var \WP_Post $objectValue */

        return wp_get_post_categories($objectValue->ID, $query);
    }
}