<?php


namespace BuilderiusPro\Bundle\GraphQLBundle\Resolver;

use Builderius\GraphQL\Type\Definition\ResolveInfo;

class PostsResolver extends AbstractPostsResolver
{
    /**
     * @inheritDoc
     */
    public function getFieldName()
    {
        return 'posts';
    }

    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        $this->graphqlFacetsCache->delete('query_args');
        $this->graphqlFacetsCache->delete('facets_args');
        $this->graphqlFacetsCache->delete('submitted_facets');
        $queryArgs = [];
        if (!empty($args)) {
            $queryArgs = $this->processQueryArgs($args, $info->path);
        }
        $this->graphqlFacetsCache->set('query_args', $queryArgs);
        $wpQuery = new \WP_Query();
        $posts = $wpQuery->query($queryArgs);
        $queryVars = $wpQuery->query_vars;

        return (object)[
            'count' => $wpQuery->post_count,
            'page' => is_int($queryVars['paged']) && $queryVars['paged'] > 0 ? $queryVars['paged'] : 1,
            'pages' => $wpQuery->max_num_pages ? : 1,
            'nodes' => $posts,
            'facets' => []
        ];
    }
}