<?php

namespace BuilderiusPro\Bundle\MetaBoxBundle\GraphQL\Resolver;

use Builderius\Bundle\GraphQLBundle\Resolver\GraphQLFieldResolverInterface;
use Builderius\GraphQL\Type\Definition\ResolveInfo;

class MetaBoxGroupFieldMultipleGroupValueResolver implements GraphQLFieldResolverInterface
{
    /**
     * @inheritDoc
     */
    public function getTypeNames()
    {
        return ['MetaBoxGroup'];
    }

    /**
     * @inheritDoc
     */
    public function getFieldName()
    {
        return 'metabox_multiple_group_value';
    }

    /**
     * @inheritDoc
     */
    public function getSortOrder()
    {
        return 10;
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($objectValue, array $args, $context, ResolveInfo $info)
    {
        return true;
    }

    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['field_id']) || !isset($objectValue[$args['field_id']])) {
            return [];
        }
        $val = $objectValue[$args['field_id']];
        if (!is_array($val)) {
            return [];
        }

        return $val;
    }
}