<?php

namespace BuilderiusPro\Bundle\MetaBoxBundle\GraphQL\Resolver;

use Builderius\Bundle\GraphQLBundle\Resolver\GraphQLFieldResolverInterface;
use Builderius\GraphQL\Type\Definition\ResolveInfo;

class MetaBoxGroupFieldPostValueResolver implements GraphQLFieldResolverInterface
{
    /**
     * @inheritDoc
     */
    public function getTypeNames()
    {
        return ['MetaBoxGroup'];
    }

    /**
     * @inheritDoc
     */
    public function getFieldName()
    {
        return 'metabox_post_value';
    }

    /**
     * @inheritDoc
     */
    public function getSortOrder()
    {
        return 10;
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($objectValue, array $args, $context, ResolveInfo $info)
    {
        return true;
    }

    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['field_id']) || !isset($objectValue[$args['field_id']])) {
            return new \stdClass();
        }
        $val = $objectValue[$args['field_id']];
        if (is_int($val) || intval($val) == $val) {
            $val = get_post($val);
        }

        return $val instanceof \WP_Post ? $val : new \stdClass();
    }
}