<?php

namespace BuilderiusPro\Bundle\MetaBoxBundle\GraphQL\Resolver;

use Builderius\Bundle\GraphQLBundle\Resolver\GraphQLFieldResolverInterface;
use Builderius\GraphQL\Type\Definition\ResolveInfo;

class MetaBoxGroupFieldSimpleValueResolver implements GraphQLFieldResolverInterface
{
    /**
     * @inheritDoc
     */
    public function getTypeNames()
    {
        return ['MetaBoxGroup'];
    }

    /**
     * @inheritDoc
     */
    public function getFieldName()
    {
        return 'metabox_value';
    }

    /**
     * @inheritDoc
     */
    public function getSortOrder()
    {
        return 10;
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($objectValue, array $args, $context, ResolveInfo $info)
    {
        return true;
    }

    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['field_id'])) {
            return null;
        }

        return isset($objectValue[$args['field_id']]) ? $objectValue[$args['field_id']] : null;
    }
}