<?php

namespace BuilderiusPro\Bundle\MetaBoxBundle\GraphQL\Resolver;

use Builderius\GraphQL\Type\Definition\ResolveInfo;

class MetaBoxPostValueResolver extends AbstractMetaBoxValueResolver
{
    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['field_id']) || (!$this->isOption && !$objectValue->ID)) {
            return new \stdClass();
        }
        $ownerType = $this->getOwnerType($objectValue);
        $fargs = (isset($args['args']) && !empty($args['args'])) ? sprintf('object_type=%s&%s', $ownerType, $args['args']) : sprintf('object_type=%s', $ownerType);
        $val = rwmb_get_value(
            $args['field_id'],
            $fargs,
            $this->getOwnerId($objectValue, $args)
        );
        if (is_int($val) || intval($val) == $val) {
            $val = get_post($val);
        }

        return $val instanceof \WP_Post ? $val : new \stdClass();
    }
}