<?php

namespace BuilderiusPro\Bundle\MetaBoxBundle\GraphQL\Resolver;

use Builderius\GraphQL\Type\Definition\ResolveInfo;

class MetaBoxValueResolver extends AbstractMetaBoxValueResolver
{
    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['field_id'])) {
            return null;
        }
        if (!$this->isOption && !$objectValue->ID && !$objectValue->term_id && !$objectValue->comment_ID) {
            return null;
        }
        $ownerType = $this->getOwnerType($objectValue);
        $fargs = (isset($args['args']) && !empty($args['args'])) ? sprintf('object_type=%s&%s', $ownerType, $args['args']) : sprintf('object_type=%s', $ownerType);

        return rwmb_get_value(
            $args['field_id'],
            $fargs,
            $this->getOwnerId($objectValue, $args)
        );
    }
}