<?php

namespace BuilderiusPro\Bundle\PolylangBundle\ApplyRule\Provider;

use Builderius\Bundle\TemplateBundle\ApplyRule\Provider\ApplyRuleArgumentsProviderInterface;

class AvailablePolylangLanguagesProvider implements ApplyRuleArgumentsProviderInterface
{
    /**
     * @inheritDoc
     */
    public function getArguments()
    {
        try {
            $pllLocales = pll_languages_list();
            $pllLangNames = pll_languages_list(['fields' => 'name']);
            $arguments = [];
            if (!empty($pllLocales)) {
                foreach ($pllLocales as $k => $locale) {
                    $arguments[] = [
                        'value' => $locale,
                        'title' => $pllLangNames[$k]
                    ];
                }
            }

            return $arguments;
        } catch(\Throwable $e) {
            return [];
        }
    }
}