<?php

namespace BuilderiusPro\Bundle\PolylangBundle\ExpressionLanguage;

use Builderius\Symfony\Component\ExpressionLanguage\ExpressionFunction;
use Builderius\Symfony\Component\ExpressionLanguage\ExpressionFunctionProviderInterface;

class PllFunctionsProvider implements ExpressionFunctionProviderInterface
{
    /**
     * @inheritDoc
     */
    public function getFunctions()
    {
        return [
            new ExpressionFunction(
                'pll_current_language',
                function ($context) {
                    return 'pll_current_language()';
                },
                function ($context) {
                    try {
                        return pll_current_language();
                    } catch (\Throwable $e) {
                        return null;
                    }

                }
            ),
        ];
    }
}