<?php

namespace BuilderiusPro\Bundle\SettingBundle\EventListener;

use Builderius\Bundle\TemplateBundle\Event\AssetRemovalEvent;
use Builderius\MooMoo\Platform\Bundle\KernelBundle\EventDispatcher\ConditionAwareEventListener;

class AbstractAssetRemovalCheckingEventListener extends ConditionAwareEventListener
{
    /**
     * @param AssetRemovalEvent $event
     * @param $libsContent
     */
    protected function processAsset(AssetRemovalEvent $event, $libsContent)
    {
        if (is_array($libsContent) && !empty($libsContent)) {
            $assetType = $event->getType();
            $assetName = $event->getName();
            foreach ($libsContent as $libsContentItem) {
                if (is_array($libsContentItem['registeredLibs'])) {
                    foreach ($libsContentItem['registeredLibs'] as $libConfig) {
                        $conf = (array)$libConfig;
                        if ($assetType === $conf['type'] && $assetName === $conf['handle']) {
                            $event->setResult(false);
                            return;
                        }
                    }
                }
            }
        }
    }
}