<?php

namespace BuilderiusPro\Bundle\SettingBundle\Provider;

class WpRegisteredScriptsProvider
{
    /**
     * @return array
     */
    public function getRegisteredScripts()
    {
        $wp_scripts = wp_scripts();
        $registeredScripts = [];
        /** @var \_WP_Dependency $registered */
        foreach ($wp_scripts->registered as $registered) {
            if (
                (!empty($registered->src) && strpos($registered->src, 'wp-admin') !== false) ||
                strpos($registered->handle, 'builderius') !== false ||
                strpos($registered->handle, 'wp-edit') === 0 ||
                strpos($registered->handle, 'wp-admin') === 0 ||
                strpos($registered->handle, 'customize-preview') === 0
            ) {
                continue;
            }
            $registeredScripts[$registered->handle] = [
                'src' => $registered->src,
                'deps' => $registered->deps,
                'ver' => $registered->ver,
            ];
        }
        ksort($registeredScripts);

        return $registeredScripts;
    }
}