<?php

namespace BuilderiusPro\Bundle\SettingBundle\Provider;

class WpRegisteredStylesProvider
{
    /**
     * @return array
     */
    public function getRegisteredStyles()
    {
        $wp_styles = wp_styles();
        $registeredStyles = [];
        /** @var \_WP_Dependency $registered */
        foreach ($wp_styles->registered as $registered) {
            if (
                (!empty($registered->src) && strpos($registered->src, 'wp-admin') !== false) ||
                strpos($registered->handle, 'builderius') !== false ||
                strpos($registered->handle, 'wp-edit') === 0 ||
                strpos($registered->handle, 'wp-admin') === 0 ||
                strpos($registered->handle, 'customize-preview') === 0 ||
                (strpos($registered->handle, 'wp-block') == 0 && substr($registered->handle, -strlen('-editor')) === '-editor')
            ) {
                continue;
            }
            $registeredStyles[$registered->handle] = [
                'src' => $registered->src,
                'deps' => $registered->deps,
                'ver' => $registered->ver,
                'extra' => $registered->extra,
            ];
        }
        ksort($registeredStyles);

        return $registeredStyles;
    }
}