<?php

namespace BuilderiusPro\Bundle\TemplateBundle\Applicant\ParametersProvider;

use Builderius\Bundle\TemplateBundle\Applicant\ParametersProvider\BuilderiusTemplateRuleApplicantParametersProviderInterface;

class BuilderiusTemplateGetHasKeyWithAnyValueApplicantParametersProvider implements BuilderiusTemplateRuleApplicantParametersProviderInterface
{
    /**
     * @inheritDoc
     */
    public function getApplicantParameters($rule, $argument, $operator, $withData = false)
    {
        return [
            [
                'GET' => [
                    [
                        'key' => $argument,
                        'value' => null,
                        'editable' => true
                    ]
                ]
            ]
        ];
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($rule, $argument, $operator)
    {
        if (strpos($rule, 'superglobal_get.key_with_any_value') !== false && !empty($argument) && $operator === '==') {
            return true;
        }

        return false;
    }
}