<?php

namespace BuilderiusPro\Bundle\TemplateBundle\Applicant\ParametersProvider;

use Builderius\Bundle\TemplateBundle\Applicant\ParametersProvider\BuilderiusTemplateRuleApplicantParametersProviderInterface;

class BuilderiusTemplateGetHasKeyWithSpecificValueApplicantParametersProvider implements BuilderiusTemplateRuleApplicantParametersProviderInterface
{
    /**
     * @inheritDoc
     */
    public function getApplicantParameters($rule, $argument, $operator, $withData = false)
    {
        return [
            [
                'GET' => [
                    [
                        'key' => $argument['key'],
                        'value' => $argument['value'],
                        'editable' => false
                    ]
                ]
            ]
        ];
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($rule, $argument, $operator)
    {
        if (strpos($rule, 'superglobal_get.key_with_specific_value') !== false &&
            is_array($argument) && array_key_exists('key', $argument) &&
            array_key_exists('value', $argument) && $operator === '=='
        ) {
            return true;
        }

        return false;
    }
}