<?php

namespace BuilderiusPro\Bundle\TemplateBundle\Applicant\Provider;

use Builderius\Bundle\TemplateBundle\Applicant\BuilderiusTemplateApplicant;
use Builderius\Bundle\TemplateBundle\Applicant\BuilderiusTemplateApplicantChangeSetInterface;
use Builderius\Bundle\TemplateBundle\Applicant\Provider\BuilderiusTemplateRuleApplicantsProviderInterface;

class BuilderiusTemplate404PageApplicantsProvider implements BuilderiusTemplateRuleApplicantsProviderInterface
{
    /**
     * @inheritDoc
     */
    public function getApplicants($rule, $argument, $operator, $withData = false)
    {
        $applicants = [];
        $applicants['singular.single.page.error_404'] =
            new BuilderiusTemplateApplicant([
                BuilderiusTemplateApplicant::LABEL_FIELD => __('Error 404 Page'),
                BuilderiusTemplateApplicant::URL_FIELD => sprintf('%s?p=-1', get_site_url()),
                BuilderiusTemplateApplicant::DATA_FIELD => [],
                BuilderiusTemplateApplicant::CATEGORY_FIELD => 'special_pages',
                BuilderiusTemplateApplicant::SORT_ORDER_FIELD => 100
            ]);

        return $applicants;
    }

    /**
     * @inheritDoc
     */
    public function getChangeSetApplicants(
        BuilderiusTemplateApplicantChangeSetInterface $changeset,
        $rule,
        $argument,
        $operator,
        $withData = false
    ) {
        return [];
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($rule, $argument, $operator)
    {
        if (strpos($rule, '404') !== false && $argument === true && $operator === '==') {
            return true;
        }

        return false;
    }
}