<?php

namespace BuilderiusPro\Bundle\TemplateBundle\ApplyRule;

use Builderius\Bundle\TemplateBundle\ApplyRule\BuilderiusTemplateApplyRule;
use Builderius\Bundle\TemplateBundle\ApplyRule\BuilderiusTemplateApplyRuleInterface;
use Builderius\Bundle\TemplateBundle\ApplyRule\BuilderiusTemplateApplyRuleVariant;
use Builderius\Bundle\TemplateBundle\ApplyRule\BuilderiusTemplateApplyRuleVariantInterface;

class BuilderiusTemplateMetaValueApplyRule extends BuilderiusTemplateApplyRule
    implements BuilderiusTemplateApplyRuleInterface
{
    /**
     * @inheritDoc
     */
    public function getVariants()
    {
        $variants = [];
        $metaValueVariant = $this->createMetaValueVariant();
        $variants[$metaValueVariant->getName()] = $metaValueVariant;
        $metaExistenceVariant = $this->createMetaExistenceVariant();
        $variants[$metaExistenceVariant->getName()] = $metaExistenceVariant;

        return $variants;
    }

    /**
     * @return  BuilderiusTemplateApplyRuleVariantInterface
     */
    private function createMetaValueVariant()
    {
        return new BuilderiusTemplateApplyRuleVariant([
            BuilderiusTemplateApplyRuleVariant::RULE_FIELD => $this->getName(),
            BuilderiusTemplateApplyRuleVariant::NAME_FIELD => 'meta_value',
            BuilderiusTemplateApplyRuleVariant::LABEL_FIELD => 'Value',
            BuilderiusTemplateApplyRuleVariant::EXPRESSION_FIELD => 'query.post.%s operator argument',
            BuilderiusTemplateApplyRuleVariant::SELECT_ALL_ALLOWED_FIELD => false,
            BuilderiusTemplateApplyRuleVariant::WIDGET_TYPE => 'keyvaluepair'
        ]);
    }

    /**
     * @return  BuilderiusTemplateApplyRuleVariantInterface
     */
    private function createMetaExistenceVariant()
    {
        return new BuilderiusTemplateApplyRuleVariant([
            BuilderiusTemplateApplyRuleVariant::RULE_FIELD => $this->getName(),
            BuilderiusTemplateApplyRuleVariant::NAME_FIELD => 'meta_existence',
            BuilderiusTemplateApplyRuleVariant::LABEL_FIELD => 'Existence',
            BuilderiusTemplateApplyRuleVariant::EXPRESSION_FIELD => 'metadata_exists("post", query.post.ID, argument) == operator',
            BuilderiusTemplateApplyRuleVariant::SELECT_ALL_ALLOWED_FIELD => false
        ]);
    }
}