<?php

namespace BuilderiusPro\Bundle\TemplateBundle\ApplyRule\Provider;

use Builderius\Bundle\TemplateBundle\ApplyRule\Provider\AbstractApplyRuleArgumentsProvider;

class AvailableCustomTaxonomiesProvider extends AbstractApplyRuleArgumentsProvider
{
    private $standardTaxonomies = [
        'category',
        'post_tag',
        'nav_menu',
        'link_category',
        'post_format',

    ];

    /**
     * @inheritDoc
     */
    public function getArguments()
    {
        global $wp_taxonomies;

        $results = [];
        /** @var \WP_Taxonomy $taxonomy */
        foreach ($wp_taxonomies as $taxonomy) {
            if ($taxonomy->public === true &&$taxonomy->_builtin === false && !in_array($taxonomy->name, $this->standardTaxonomies) && strpos($taxonomy->name, 'builderius') === false) {
                $results[] = ['value' => $taxonomy->name, 'title' => $taxonomy->label];
            }
        }
        $results = $this->sort($results);

        return $results;
    }
}
