<?php

namespace BuilderiusPro\Bundle\TemplateBundle\ApplyRule\Provider;

use Builderius\Bundle\TemplateBundle\ApplyRule\Provider\AbstractApplyRuleArgumentsProvider;

class AvailableNavMenusProvider extends AbstractApplyRuleArgumentsProvider
{
    const CACHE_KEY = 'builderius_available_nav_menus_for_apply_rules';

    /**
     * @inheritDoc
     */
    public function getArguments()
    {
        $results = wp_cache_get(self::CACHE_KEY);
        if (false === $results) {
            $results = [];
            $menus = wp_get_nav_menus();
            /** @var \WP_Term[] $menu */
            foreach ($menus as $menu) {
                $results[] = [
                    'value' => $menu->slug,
                    'title' => $menu->name
                ];
            }
            $results = $this->sort($results);
            wp_cache_set(self::CACHE_KEY, $results);
        }

        return $results;
    }
}
