<?php

namespace BuilderiusPro\Bundle\TemplateBundle\ApplyRule\Provider;

use Builderius\Bundle\TemplateBundle\ApplyRule\Provider\AbstractApplyRuleArgumentsProvider;

class AvailableRolesProvider extends AbstractApplyRuleArgumentsProvider
{
    /**
     * @inheritDoc
     */
    public function getArguments()
    {
        /** @var \WP_Roles $roles */
        $roles = wp_roles();
        
        $results = [];
        foreach ($roles->get_names() as $name => $label) {
            $results[] = ['value' => $name, 'title' => translate_user_role($label)];
        }
        $results = $this->sort($results);
        
        return $results;
    }
}
