<?php

namespace BuilderiusPro\Bundle\TemplateBundle\ApplyRule\Starter;

use Builderius\Bundle\TemplateBundle\ApplyRule\Starter\BuilderiusTemplateApplyRuleStarterInterface;

class UserWithIdApplyRuleStarter implements BuilderiusTemplateApplyRuleStarterInterface
{

    /**
     * @inheritDoc
     */
    public function getName()
    {
        return 'user_with_id';
    }

    /**
     * @inheritDoc
     */
    public function getTitle()
    {
        return sprintf("User with ID#%d", $this->getFirstUserId());
    }

    /**
     * @inheritDoc
     */
    public function getCategory()
    {
        return 'user';
    }

    /**
     * @inheritDoc
     */
    public function getTemplateTypes()
    {
        return ['template', 'template_part'];
    }

    /**
     * @inheritDoc
     */
    public function getTechnologies()
    {
        return ['html'];
    }

    /**
     * @inheritDoc
     */
    public function getConfig()
    {
        return [
            "user" => [
                "rules" => [
                    [
                        "value" => "user",
                        "type" => "chain",
                        "name" => "user",
                        "rules" => [
                            [
                                "type" => "select",
                                "name" => "user_with_id",
                                "value" => $this->getFirstUserId(),
                                "operator" => "=="
                            ]
                        ],
                        "condition" => "and"
                    ]
                ],
                "condition" => "and",
                "type" => "group"
            ]
        ];
    }

    /**
     * @return int
     */
    private function getFirstUserId()
    {
        $users = get_users();
        $user = reset($users);

        return $user->ID;
    }

    /**
     * @inheritDoc
     */
    public function isValid()
    {
        return true;
    }
}