<?php

namespace BuilderiusPro\Bundle\TemplateBundle;

use Builderius\MooMoo\Platform\Bundle\KernelBundle\Bundle\Bundle;
use Builderius\MooMoo\Platform\Bundle\KernelBundle\DependencyInjection\CompilerPass\KernelCompilerPass;
use Builderius\Symfony\Component\DependencyInjection\ContainerBuilder;
use BuilderiusPro\Bundle\TemplateBundle\DependencyInjection\CompilerPass\BranchesCountCheckRemovalCompilerPass;

class BuilderiusProTemplateBundle extends Bundle
{
    /**
     * {@inheritdoc}
     */
    public function build(ContainerBuilder $container)
    {
        parent::build($container);

        $container->addCompilerPass(new BranchesCountCheckRemovalCompilerPass());
        $container->addCompilerPass(
            new KernelCompilerPass(
                'builderius_available_singulars_provider_name',
                'builderiuspro_template.apply_rule.arguments_provider.available_singulars.name',
                'addProvider'
            )
        );
        $container->addCompilerPass(
            new KernelCompilerPass(
                'builderius_available_singulars_provider_title',
                'builderiuspro_template.apply_rule.arguments_provider.available_singulars.title',
                'addProvider'
            )
        );
    }
}
