<?php

namespace BuilderiusPro\Bundle\TemplateBundle\Converter\Version\v0_10_0;

use Builderius\Bundle\ModuleBundle\Model\BuilderiusModule;
use Builderius\Bundle\TemplateBundle\Converter\ConfigToHierarchicalConfigConverter;
use Builderius\Bundle\TemplateBundle\Converter\Version\BuilderiusTemplateConfigVersionConverterInterface;
use Builderius\Bundle\TemplateBundle\Converter\Version\BuilderiusTemplateConfigVersionOrderedConverterInterface;

class BuilderiusTemplateConfigModulesConverter implements BuilderiusTemplateConfigVersionConverterInterface,
    BuilderiusTemplateConfigVersionOrderedConverterInterface
{
    /**
     * @inheritDoc
     */
    public function getVersion()
    {
        return '0.10.0';
    }

    /**
     * @inheritDoc
     */
    public function getOrder()
    {
        return 10;
    }

    /**
     * @inheritDoc
     */
    public function convert(array $config)
    {
        if (isset($config[ConfigToHierarchicalConfigConverter::CONFIG_MODULES_KEY]) && is_array($config[ConfigToHierarchicalConfigConverter::CONFIG_MODULES_KEY])) {
            foreach ($config[ConfigToHierarchicalConfigConverter::CONFIG_MODULES_KEY] as $moduleId => $moduleConfig) {
                if (isset($moduleConfig['name'])) {
                    if ($moduleConfig['name'] === 'DynamicSpan') {
                        $config[ConfigToHierarchicalConfigConverter::CONFIG_MODULES_KEY][$moduleId]['name'] = 'DynamicOutput';
                        if ($moduleConfig['label'] === 'Dynamic Span') {
                            $config[ConfigToHierarchicalConfigConverter::CONFIG_MODULES_KEY][$moduleId]['label'] = 'Dynamic Output';
                        }
                        if (isset($moduleConfig[BuilderiusModule::SETTINGS_FIELD])) {
                            foreach ($moduleConfig[BuilderiusModule::SETTINGS_FIELD] as $index => $settingConfig) {
                                if ($settingConfig['name'] === 'dataDynamicSpan') {
                                    $config[ConfigToHierarchicalConfigConverter::CONFIG_MODULES_KEY][$moduleId][BuilderiusModule::SETTINGS_FIELD][$index]['name'] = 'dataDynamicOutput';
                                }
                            }
                        }
                    } elseif ($moduleConfig['name'] === 'DynamicUList') {
                        $config[ConfigToHierarchicalConfigConverter::CONFIG_MODULES_KEY][$moduleId]['name'] = 'CollectionUL';
                        if ($moduleConfig['label'] === 'Dynamic UList') {
                            $config[ConfigToHierarchicalConfigConverter::CONFIG_MODULES_KEY][$moduleId]['label'] = 'Collection UL';
                        }
                    }
                }
            }
        }

        return $config;
    }
}