<?php

namespace BuilderiusPro\Bundle\TemplateBundle\DependencyInjection\CompilerPass;

use Builderius\Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Builderius\Symfony\Component\DependencyInjection\ContainerBuilder;

class BranchesCountCheckRemovalCompilerPass implements CompilerPassInterface
{
    const SERVICE_DEFINITION = 'builderius_template.event_listener.branches_count_checking';

    /**
     * {@inheritDoc}
     */
    public function process(ContainerBuilder $container)
    {
        if (!$container->hasDefinition(self::SERVICE_DEFINITION)) {
            return;
        }
        $definition = $container->getDefinition(self::SERVICE_DEFINITION);

        $definition->clearTags();

        $container->setDefinition(self::SERVICE_DEFINITION, $definition);
    }
}
