<?php

namespace BuilderiusPro\Bundle\TemplateBundle\Event;

use Builderius\Bundle\TemplateBundle\ApplyRule\BuilderiusTemplateApplyRuleInterface;
use Builderius\Bundle\TemplateBundle\ApplyRule\Provider\AvailablePostsProvider;
use Builderius\Symfony\Contracts\EventDispatcher\Event;

class CustomPostApplyRuleEvent extends Event
{
    /**
     * @var string
     */
    private $postType;

    /**
     * @var BuilderiusTemplateApplyRuleInterface
     */
    private $applyRule;

    /**
     * @var AvailablePostsProvider
     */
    private $availablePostsProvider;

    /**
     * @param string $postType
     * @param BuilderiusTemplateApplyRuleInterface $applyRule
     * @param AvailablePostsProvider $availablePostsProvider
     */
    public function __construct(
        $postType,
        BuilderiusTemplateApplyRuleInterface $applyRule,
        AvailablePostsProvider $availablePostsProvider
    ) {
        $this->postType = $postType;
        $this->applyRule = $applyRule;
        $this->availablePostsProvider = $availablePostsProvider;
    }

    /**
     * @return string
     */
    public function getPostType()
    {
        return $this->postType;
    }

    /**
     * @return AvailablePostsProvider
     */
    public function getAvailablePostsProvider()
    {
        return $this->availablePostsProvider;
    }

    /**
     * @return BuilderiusTemplateApplyRuleInterface
     */
    public function getApplyRule()
    {
        return $this->applyRule;
    }

    /**
     * @param BuilderiusTemplateApplyRuleInterface $applyRule
     * @return $this
     */
    public function setApplyRule(BuilderiusTemplateApplyRuleInterface $applyRule)
    {
        $this->applyRule = $applyRule;

        return $this;
    }
}