<?php

namespace BuilderiusPro\Bundle\TemplateBundle\EventListener;

use Builderius\MooMoo\Platform\Bundle\AssetBundle\Model\AssetDataItem;
use Builderius\MooMoo\Platform\Bundle\AssetBundle\Model\InlineAsset;
use Builderius\MooMoo\Platform\Bundle\KernelBundle\EventDispatcher\ConditionAwareEventListener;

abstract class AbstractAssetsRegistrationEventListener extends ConditionAwareEventListener
{
    /**
     * @param array $config
     * @param string $type
     * @param string $class
     * @return InlineAsset
     */
    protected function createAsset(array $config, $type, $class)
    {
        $asset = new InlineAsset([
            InlineAsset::TYPE_FIELD => $type,
            InlineAsset::ID_FIELD => isset($config['id']) ? $config['id'] : null,
            InlineAsset::CONTENT_FIELD => $config['content'],
        ]);
        $assetDataItem = new AssetDataItem([
            AssetDataItem::GROUP_FIELD => 'htmlAttributes',
            AssetDataItem::KEY_FIELD => 'class',
            AssetDataItem::VALUE_FIELD => $class
        ]);
        $asset->addAssetDataItem($assetDataItem);
        if (isset($config['attributes'])) {
            foreach ($config['attributes'] as $attribute) {
                $attribute = (array)$attribute;
                if (array_key_exists('a1', $attribute) && array_key_exists('b1', $attribute)) {
                    $dataItem = new AssetDataItem([
                        AssetDataItem::GROUP_FIELD => 'htmlAttributes',
                        AssetDataItem::KEY_FIELD => $attribute['a1'],
                        AssetDataItem::VALUE_FIELD => $attribute['b1']
                    ]);
                    $asset->addAssetDataItem($dataItem);
                }
            }
        }

        return $asset;
    }
}