<?php

namespace BuilderiusPro\Bundle\TemplateBundle\EventListener;

use Builderius\Bundle\TemplateBundle\Event\AssetRemovalEvent;
use Builderius\Bundle\TemplateBundle\Provider\DeliverableTemplateSubModule\DeliverableTemplateSubModuleProviderInterface;
use BuilderiusPro\Bundle\SettingBundle\EventListener\AbstractAssetRemovalCheckingEventListener;
use BuilderiusPro\Bundle\TemplateBundle\Provider\Content\Template\BuilderiusTemplateLibrariesContentProvider;

class AssetRemovalCheckingInFrontendModeEventListener extends AbstractAssetRemovalCheckingEventListener
{
    /**
     * @var DeliverableTemplateSubModuleProviderInterface
     */
    private $dtsmProvider;

    /**
     * @param DeliverableTemplateSubModuleProviderInterface $dtsmProvider
     */
    public function __construct(
        DeliverableTemplateSubModuleProviderInterface $dtsmProvider
    ) {
        $this->dtsmProvider = $dtsmProvider;
    }

    /**
     * @param AssetRemovalEvent $event
     * @throws \Exception
     */
    public function beforeAssetRemoval(AssetRemovalEvent $event)
    {
        $templateSubModule = $this->dtsmProvider->getTemplateSubModule();
        if ($templateSubModule) {
            if ($libsContent = $templateSubModule->getContent(BuilderiusTemplateLibrariesContentProvider::CONTENT_TYPE)) {
                $this->processAsset($event, $libsContent);
            }
        }
    }
}