<?php

namespace BuilderiusPro\Bundle\TemplateBundle\EventListener;

use Builderius\Bundle\TemplateBundle\Event\AssetRemovalEvent;
use Builderius\Bundle\TemplateBundle\Provider\DeliverableTemplateSubModule\DeliverableTemplateSubModuleProviderInterface;
use Builderius\Bundle\TemplateBundle\Provider\DeliverableTemplateSubModule\DeliverableTemplateSubModulesProviderInterface;
use BuilderiusPro\Bundle\SettingBundle\EventListener\AbstractAssetRemovalCheckingEventListener;
use BuilderiusPro\Bundle\TemplateBundle\Provider\Content\Template\BuilderiusTemplateLibrariesContentProvider;

class AssetRemovalCheckingInHookTemplatesFrontendModeEventListener extends AbstractAssetRemovalCheckingEventListener
{
    /**
     * @var DeliverableTemplateSubModulesProviderInterface
     */
    private $dhtsmsProvider;

    /**
     * @param DeliverableTemplateSubModulesProviderInterface $dhtsmsProvider
     */
    public function __construct(
        DeliverableTemplateSubModulesProviderInterface $dhtsmsProvider
    ) {
        $this->dhtsmsProvider = $dhtsmsProvider;
    }

    /**
     * @param AssetRemovalEvent $event
     * @throws \Exception
     */
    public function beforeAssetRemoval(AssetRemovalEvent $event)
    {
        $templateSubModules = $this->dhtsmsProvider->getTemplateSubModules();
        if (!empty($templateSubModules)) {
            foreach ($templateSubModules as $templateSubModule) {
                if ($libsContent = $templateSubModule->getContent(BuilderiusTemplateLibrariesContentProvider::CONTENT_TYPE)) {
                    $this->processAsset($event, $libsContent);
                }
            }
        }
    }
}