<?php

namespace BuilderiusPro\Bundle\TemplateBundle\EventListener;

use Builderius\Bundle\TemplateBundle\Event\AssetRemovalEvent;
use Builderius\Bundle\TemplateBundle\Provider\Template\BuilderiusTemplatesProviderInterface;
use BuilderiusPro\Bundle\SettingBundle\EventListener\AbstractAssetRemovalCheckingEventListener;
use BuilderiusPro\Bundle\TemplateBundle\Provider\Content\Template\BuilderiusTemplateLibrariesContentProvider;

class AssetRemovalCheckingInHookTemplatesPreviewModeEventListener extends AbstractAssetRemovalCheckingEventListener
{
    /**
     * @var BuilderiusTemplatesProviderInterface
     */
    private $builderiusHookTemplatesProvider;

    /**
     * @param BuilderiusTemplatesProviderInterface $builderiusHookTemplatesProvider
     */
    public function __construct(
        BuilderiusTemplatesProviderInterface $builderiusHookTemplatesProvider
    ) {
        $this->builderiusHookTemplatesProvider = $builderiusHookTemplatesProvider;
    }

    /**
     * @param AssetRemovalEvent $event
     */
    public function beforeAssetRemoval(AssetRemovalEvent $event)
    {
        $templates = $this->builderiusHookTemplatesProvider->getTemplates();
        if (!empty($templates)) {
            foreach ($templates as $template) {
                if ($branch = $template->getActiveBranch()) {
                    if ($libsContent = $branch->getContent(BuilderiusTemplateLibrariesContentProvider::CONTENT_TYPE)) {
                        $this->processAsset($event, $libsContent);
                    } elseif ($commit = $branch->getActiveCommit()) {
                        if ($libsContent = $commit->getContent(BuilderiusTemplateLibrariesContentProvider::CONTENT_TYPE)) {
                            $this->processAsset($event, $libsContent);
                        }
                    }
                }
            }
        }
    }
}