<?php

namespace BuilderiusPro\Bundle\TemplateBundle\EventListener;

use Builderius\Bundle\TemplateBundle\Provider\DeliverableTemplateSubModule\DeliverableTemplateSubModuleProviderInterface;
use Builderius\MooMoo\Platform\Bundle\AssetBundle\Event\InlineAssetsContainingEvent;
use BuilderiusPro\Bundle\TemplateBundle\Provider\Content\Template\BuilderiusTemplateJsContentProvider;

class JsRegistrationInFrontendModeEventListener extends AbstractAssetsRegistrationEventListener
{
    /**
     * @var DeliverableTemplateSubModuleProviderInterface
     */
    private $dtsmProvider;

    /**
     * @param DeliverableTemplateSubModuleProviderInterface $dtsmProvider
     */
    public function __construct(
        DeliverableTemplateSubModuleProviderInterface $dtsmProvider
    ) {
        $this->dtsmProvider = $dtsmProvider;
    }

    /**
     * @param InlineAssetsContainingEvent $event
     * @throws \Exception
     */
    public function beforeAssetsRegistration(InlineAssetsContainingEvent $event)
    {
        $assets = $event->getAssets();
        $templateSubModule = $this->dtsmProvider->getTemplateSubModule();
        if ($templateSubModule) {
            if ($jsContent = $templateSubModule->getContent(BuilderiusTemplateJsContentProvider::CONTENT_TYPE)) {
                if (is_array($jsContent) && !empty($jsContent)) {
                    foreach ($jsContent as $jsContentItem) {
                        $assets[] = $this->createAsset((array)$jsContentItem, 'script', 'builderius-js');
                    }
                }
            }
        }
        $event->setAssets($assets);
    }
}