<?php

namespace BuilderiusPro\Bundle\TemplateBundle\EventListener;

use Builderius\Bundle\TemplateBundle\Provider\DeliverableTemplateSubModule\DeliverableTemplateSubModulesProviderInterface;
use Builderius\MooMoo\Platform\Bundle\AssetBundle\Event\InlineAssetsContainingEvent;
use BuilderiusPro\Bundle\TemplateBundle\Provider\Content\Template\BuilderiusTemplateJsContentProvider;

class JsRegistrationInHookTemplatesFrontendModeEventListener extends AbstractAssetsRegistrationEventListener
{
    /**
     * @var DeliverableTemplateSubModulesProviderInterface
     */
    private $dhtsmsProvider;

    /**
     * @param DeliverableTemplateSubModulesProviderInterface $dhtsmsProvider
     */
    public function __construct(
        DeliverableTemplateSubModulesProviderInterface $dhtsmsProvider
    ) {
        $this->dhtsmsProvider = $dhtsmsProvider;
    }

    /**
     * @param InlineAssetsContainingEvent $event
     * @throws \Exception
     */
    public function beforeAssetsRegistration(InlineAssetsContainingEvent $event)
    {
        $assets = $event->getAssets();
        $templateSubModules = $this->dhtsmsProvider->getTemplateSubModules();
        if (!empty($templateSubModules)) {
            foreach ($templateSubModules as $templateSubModule) {
                if ($jsContent = $templateSubModule->getContent(BuilderiusTemplateJsContentProvider::CONTENT_TYPE)) {
                    if (is_array($jsContent) && !empty($jsContent)) {
                        foreach ($jsContent as $jsContentItem) {
                            $assets[] = $this->createAsset((array)$jsContentItem, 'script', 'builderius-js');
                        }
                    }
                }
            }
        }
        $event->setAssets($assets);
    }
}