<?php

namespace BuilderiusPro\Bundle\TemplateBundle\ExpressionLanguage;

use Builderius\Symfony\Component\ExpressionLanguage\ExpressionFunction;
use Builderius\Symfony\Component\ExpressionLanguage\ExpressionFunctionProviderInterface;

class WpFunctionsProvider implements ExpressionFunctionProviderInterface
{
    /**
     * @inheritDoc
     */
    public function getFunctions()
    {
        return [
            new ExpressionFunction(
                'wp_is_mobile',
                function ($context) {
                    return 'wp_is_mobile()';
                },
                function ($context) {
                    return wp_is_mobile();
                }
            ),
            new ExpressionFunction(
                'is_ios',
                function ($context) {
                    return 'is_ios';
                },
                function ($context) {
                    return (new \WP_Customize_Manager())->is_ios();
                }
            ),
            new ExpressionFunction(
                'pll_get_post_translations',
                function ($context, $postId) {
                    return sprintf('pll_get_post_translations(%s)', $postId);
                },
                function ($context, $postId) {
                    try {
                        $postIds = pll_get_post_translations($postId);
                    } catch (\Exception $e) {
                        $postIds = [];
                    }

                    return $postIds;
                }
            ),
        ];
    }
}