<?php

namespace BuilderiusPro\Bundle\TemplateBundle\Hook;

use Builderius\MooMoo\Platform\Bundle\HookBundle\Model\AbstractAction;
use BuilderiusPro\Bundle\TemplateBundle\ApplyRule\Provider\AvailableUsersProvider;

class AvailableUsersCacheUpdateOnUserDeleteHook extends AbstractAction
{
    /**
     * @inheritDoc
     */
    public function getFunction()
    {
        $userId = func_get_arg(0);
        $cache = wp_cache_get(AvailableUsersProvider::CACHE_KEY);
        if (false !== $cache && is_array($cache)) {
            if (is_array($cache['objects'])) {
                unset($cache['objects'][$userId]);
            }
            foreach ($cache as $field => $fieldCache) {
                if ($field !== 'objects') {
                    unset($cache[$field]['not_sorted'][$userId]);
                    $cache[$field]['sorted'] =
                        $this->sort($cache[$field]['not_sorted']);
                }
            }
            wp_cache_set(AvailableUsersProvider::CACHE_KEY, $cache);
        }
    }

    /**
     * @param array $results
     */
    private function sort (array $results)
    {
        usort ($results, function ($a, $b) {
            if ($a['value'] < $b['value']) {
                return -1;
            } elseif ($a['value'] > $b['value']) {
                return 1;
            }

            return 0;
        });

        return $results;
    }
}