<?php

namespace BuilderiusPro\Bundle\TemplateBundle\Hook;

use Builderius\MooMoo\Platform\Bundle\HookBundle\Model\AbstractAction;
use BuilderiusPro\Bundle\TemplateBundle\ApplyRule\Provider\AvailableUsersProvider;

class AvailableUsersCacheUpdateOnUserSaveHook extends AbstractAction
{
    /**
     * @inheritDoc
     */
    public function getFunction()
    {
        $userId = func_get_arg(0);
        $user = get_user_by('ID', $userId);
        if ($user instanceof \WP_User) {
            $cache = wp_cache_get(AvailableUsersProvider::CACHE_KEY);
            if (false !== $cache && is_array($cache)) {
                if (is_array($cache['objects'])) {
                    $cache['objects'][$user->ID] = $user;
                }
                foreach ($cache as $field => $fieldCache) {
                    if ($field !== 'objects') {
                        if ($user->{$field} === $user->display_name) {
                            $title = $user->display_name;
                        } else {
                            $title = sprintf(
                                '%s%s (%s)',
                                $field === 'ID' ? '#' : '',
                                $user->{$field},
                                $user->display_name
                            );
                        }
                        $cache[$field]['not_sorted'][$user->ID] = [
                            'value' => $user->{$field},
                            'title' => $title
                        ];
                        $cache[$field]['sorted'] =
                            $this->sort($cache[$field]['not_sorted']);
                    }
                }
                wp_cache_set(AvailableUsersProvider::CACHE_KEY, $cache);
            }
        }
    }

    /**
     * @param array $results
     */
    private function sort (array $results)
    {
        usort ($results, function ($a, $b) {
            if ($a['value'] < $b['value']) {
                return -1;
            } elseif ($a['value'] > $b['value']) {
                return 1;
            }

            return 0;
        });

        return $results;
    }
}