<?php

namespace BuilderiusPro\Bundle\UpdateBundle\Condition;

use Builderius\MooMoo\Platform\Bundle\ConditionBundle\Model\AbstractCondition;
use BuilderiusPro\Bundle\UpdateBundle\Model\Activation;

class BuilderiusProActivatedCondition extends AbstractCondition
{
    /**
     * @inheritDoc
     */
    protected function getResult()
    {
        $licenseDetails = Activation::getDetails();
        $licenseKey = Activation::getKey();
        $licenseStatus = Activation::getStatus();

        if (!$licenseKey || $licenseStatus !== 'valid') {
            return false;
        }

        if (!isset($licenseDetails->expires)) {
            return false;
        }

        $expireDate = strtotime($licenseDetails->expires);
        $currentDate = time();

        return (($expireDate > $currentDate) || ($licenseDetails->expires === 'lifetime'));
    }
}