<?php

namespace BuilderiusPro\Bundle\UpdateBundle\Helper;

class UpdateHelper
{
    const CACHE_KEY = 'builderius_pro_version_info';

    /**
     * @return boolean|string
     */
    public static function getCachedVersionInfo()
    {
        $cache = get_option(self::CACHE_KEY);

        if (empty($cache['timeout']) || time() > $cache['timeout']) {
            return false;
        }

        $cache['value'] = json_decode($cache['value']);
        if (!empty($cache['value']->icons)) {
            $cache['value']->icons = (array)$cache['value']->icons;
        }

        return $cache['value'];
    }

    /**
     * @param string $value
     */
    public static function setCachedVersionInfo($value)
    {
        $data = array(
            'timeout' => strtotime('+1 hour', time()),
            'value' => json_encode($value)
        );

        update_option(self::CACHE_KEY, $data, 'no');
    }
}