<?php

namespace BuilderiusPro\Bundle\UpdateBundle\Hook;

use Builderius\MooMoo\Platform\Bundle\HookBundle\Model\AbstractFilter;
use Builderius\MooMoo\Platform\Bundle\KernelBundle\Provider\PluginsVersionsProvider;
use BuilderiusPro\Bundle\UpdateBundle\Model\Activation;

class UpgraderPreDownloadHook extends AbstractFilter
{
    /**
     * @var PluginsVersionsProvider
     */
    private $pluginsVersionsProvider;

    /**
     * @param PluginsVersionsProvider $pluginsVersionsProvider
     * @return $this
     */
    public function setPluginsVersionsProvider(PluginsVersionsProvider $pluginsVersionsProvider)
    {
        $this->pluginsVersionsProvider = $pluginsVersionsProvider;

        return $this;
    }

    /**
     * @return {@inheritDoc}}
     */
    public function getFunction()
    {
        $result = func_get_arg(0);

        $package = func_get_arg(1);
        if (strpos($package, 'my.builderius.io/wp-json/wp/v2/version-download') === false) {
            return $result;
        }
        $builderiusProVersion = $this->pluginsVersionsProvider->getPluginVersion('builderius-pro');
        $activationCode = Activation::getKey();
        $builderiusVersion = $this->pluginsVersionsProvider->getPluginVersion('builderius');
        $hash = base64_encode(sprintf('%s-|-%s-|-%s', $activationCode, $builderiusVersion, $builderiusProVersion));
        try {
            $response = wp_remote_get(CheckForUpdateHook::VERSION_INFO_URL . '?hash=' . urlencode($hash));
            $remoteVersionInfo = json_decode(wp_remote_retrieve_body($response), true);
            if (count($remoteVersionInfo) === 2 && isset($remoteVersionInfo['status']) && isset($remoteVersionInfo['message'])) {
                update_option(Activation::ACTIVATION_STATUS_OPTION_FIELD, $remoteVersionInfo['status']);
                update_option(Activation::ACTIVATION_DETAILS_OPTION_FIELD, $remoteVersionInfo);
            }
        } catch (\Exception $e) {
            return $result;
        }

        return $result;
    }
}